import os.path


dilloDir = r"C:\Program Files\Armadillo Run\Levels"

inFilename = "Empty.lvl"

minDillos = 2
maxDillos = 5

dilloSizes = [
    0.2,
    0.5,
    1.0,
    2.0,
]

levelCount = 1


def buildLevel(dillos):
    global levelCount
    inFile = open(os.path.join(dilloDir,inFilename),"rb")
    inFile.seek(0,2)
    dataSize = inFile.tell()

    inFile.seek(-4,2)
    s = inFile.read(4)
    (xorCheck,) = struct.unpack("I",s)
    #print "Starting 0x%08X"%(xorCheck)

    outFilename = "MultiDillo-%d.lvl"%(levelCount)
    levelCount+=1

    outFile = open(os.path.join(dilloDir,outFilename),"wb")
    inFile.seek(0,0)
    outFile.write(inFile.read(dataSize))

    #remove the old data from the checksum
    inFile.seek(-(68),2)
    oldDilloData = inFile.read(7*4)
    for i in struct.unpack("7I",oldDilloData):
        xorCheck^=i


    #write out the new count
    outFile.seek(-(68),2)
    dilloCountData = struct.pack("I",(len(dillos)))
    outFile.write(dilloCountData)
    xorCheck ^= struct.unpack("I",dilloCountData)[0]

    #write out the new dillos
    for dillo in dillos:
        #print `dillo`
        dilloData = struct.pack("6f",*dillo)
        outFile.write(dilloData)
        for i in struct.unpack("6I",dilloData):
            xorCheck ^= i


    #write out the rest of the file
    inFile.seek(-(68-7*4),2)
    outFile.write(inFile.read(dataSize-inFile.tell()))

    #write out the new checksum
    outFile.seek(-4,2)
    outFile.write(struct.pack("I",xorCheck))

    inFile.close()
    outFile.close()

def buildLists(numDillos,minDilloSize,maxDilloSize):
    l = []
    y = ((maxDilloSize+0.1)*(numDillos-1))
    yIncrement = -(maxDilloSize+0.1)*2.0
    dilloX = -(maxDilloSize+0.2)
    portalX = (maxDilloSize+0.2)
    dilloSize = minDilloSize
    dilloSizeIncrement = (maxDilloSize-minDilloSize)/(numDillos-1)
    for dillo in range(0,numDillos):
        l.append((dilloX,y,dilloSize,portalX,y,dilloSize+0.1))
        y+=yIncrement
        dilloSize+=dilloSizeIncrement
    return l
    

for numDillos in range(minDillos,maxDillos+1):
    print `numDillos`
    for dilloSize in dilloSizes:
        buildLevel(buildLists(numDillos,dilloSize,dilloSize))
    buildLevel(buildLists(numDillos,dilloSizes[0],dilloSizes[len(dilloSizes)-1]))        