from operator import xor

import struct
import os


files= [
    "Tutorial 1 - Introduction.lvl"        
    "Tutorial 1 - Introduction.lvl"        
#    "empty.lvl",
#    "Alphabet 1 - A.lvl",
#    "Alphabet 10 - J.lvl",
]

FEATURE_FLAG_TOOLS = 0x00000002

xorCheck = 0

def parseFile(filename):
    global xorCheck
    f = open(filename,"rb")
    f.seek(0,2)
    size = f.tell()
    f.seek(0,0)
    xorCheck = 0

    def feedChecksum(data,format):
        global xorCheck
        str = struct.pack(format,data)
        while len(str)<4:
            str='\0'+str
            #print "PACKING!"
        #print "len=%d"%(len(str))
        (i,) = struct.unpack("I",str)
        xorCheck = xor(xorCheck,i)


    def formatBinaryBuffer(data):
        str=""
        for b in data:
            str+="%02X " %(ord(b))
        return str            

    #read header
    headerFmt="4sIIffffI"
    headerSize = 8*4
    data = f.read(headerSize)
    unpackedData = struct.unpack(headerFmt,data)
    (magic,features,background,leftBound,rightBound,bottomBound,topBound,budget) = unpackedData
    feedChecksum(background,"I")
    feedChecksum(leftBound,"f")
    feedChecksum(rightBound,"f")
    feedChecksum(bottomBound,"f")
    feedChecksum(topBound,"f")
    feedChecksum(budget,"I")
    print file
    print "magic=%s\nfeatures=%d\nbackground=%d\nleft=%f\nright=%f\nbottom=%f\ntop=%f\nbudget=%d\n"%unpackedData

    #read anchors
    anchorData=f.read(4)
    (numAnchors,)=struct.unpack("I",anchorData)
    feedChecksum(numAnchors,"I")
    print "numAnchors=%d"%(numAnchors)

    for i in range(0,numAnchors):
        anchorData = f.read(4*4)
        (index,flags,x,y)=struct.unpack("IIff",anchorData)
        feedChecksum(index,"I")
        feedChecksum(flags,"I")
        feedChecksum(x,"f")
        feedChecksum(y,"f")
        
        
        print "\tindex=0x%08X, flags=0x%08X, x=%f, y=%f"%(index,flags,x,y,)

    #read Connections
    conData = f.read(4)
    (numConnections,)=struct.unpack("I",conData)
    feedChecksum(numConnections,"I")
    print "numConnections=%d"%(numConnections)
    for i in range(0,numConnections):
        conSize= 20
        conData = f.read(conSize)
        #print formatBinaryBuffer(conData)        
        unpackedCon=struct.unpack("IIIII",conData)
        (index,unknown0,type,fromindex,toindex)=unpackedCon
        feedChecksum(index,"I")
        feedChecksum(unknown0,"I")
        feedChecksum(type,"I")
        feedChecksum(fromindex,"I")
        feedChecksum(toindex,"I")
        tension = 0.0
        (hasTension,)=struct.unpack("B",f.read(1))
        feedChecksum(hasTension,"B")
        if hasTension!=0:
            tensionData = f.read(4)
            #print formatBinaryBuffer(tensionData)        
            (tension,) = struct.unpack("f",tensionData)
            feedChecksum(tension,"f")
        timer = 0.0        
        (hasTimer,)=struct.unpack("B",f.read(1))
        feedChecksum(hasTimer,"B")
        if hasTimer!=0:
            timerData = f.read(4)
            #print formatBinaryBuffer(timerData)        
            (timer,) = struct.unpack("I",timerData)
            feedChecksum(timer,"f")
        print "\tindex=%d unknown0=%d type=%d fromindex=%d toindex=%d hasTension=%d hasTimer=%d tension=%f timer=%d"%(index,unknown0,type,fromindex,toindex,hasTension,hasTimer,tension,timer)

    print ""


    #read unknown
    if (features&FEATURE_FLAG_TOOLS)!=0:
        tailSize = 74
    else:
        tailSize = 64

    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
    unknownData =f.read((size-tailSize)-f.tell())
    unknown = struct.unpack("%dI"%(len(unknownData)/4),unknownData)
    for u in unknown:
        feedChecksum(u,"I")

    unknownBlock =  formatBinaryBuffer(unknownData)
    print "UNKNOWN BLOCK = "+unknownBlock
    print ""

##    #read unknown
##    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
##    unknownData = f.read(4)
##    (unknown,)=struct.unpack("I",unknownData)
##    feedChecksum(unknown,"I")
##    print "unknown1 count=0x%08X"%(unknown)
##    for i in range(0,unknown):
##        unknownSize= 4
##        unknownData = f.read(unknownSize)
##        print "\t"+formatBinaryBuffer(unknownData)
##        unknown = struct.unpack("I",unknownData)
##        for u in unknown:
##            feedChecksum(u,"I")


##    #read unknown
##    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
##    unknownData = f.read(4)
##    (unknown,)=struct.unpack("I",unknownData)
##    feedChecksum(unknown,"I")
##    print "unknown2 =0x%08X"%(unknown)
###    for i in range(0,unknown):
###        unknownSize= 4
###        unknownData = f.read(unknownSize)
###        print "\t"+formatBinaryBuffer(unknownData)
###        unknown = struct.unpack("I",unknownData)
###        for u in unknown:
###            feedChecksum(u,"I")
##            
##        
##    print ""
##
##    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
##    #read armadillo
##    #dilloData = f.read(4)
###    (numDillos,)=struct.unpack("I",dilloData)
###    feedChecksum(numDillos,"I")
## #   print "numDillos(?)=%d"%(numDillos)
###    for i in range(0,1):

    dilloSize= 8
    dilloData = f.read(dilloSize)
    #print formatBinaryBuffer(conData)        
    unpackedDillo=struct.unpack("ff",dilloData)
    (dilloX,dilloY)=unpackedDillo
    feedChecksum(dilloX,"f")
    feedChecksum(dilloY,"f")
    print "dilloX=%f dilloY=%f"%unpackedDillo

    print ""


    #read unknown
    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
    unknownData = f.read(4)
    (unknown,)=struct.unpack("I",unknownData)
    feedChecksum(unknown,"I")
    print "unknown=0x%08X"%(unknown)
    print ""

    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
    #read portal
    portalSize= 8
    portalData = f.read(portalSize)
    #print formatBinaryBuffer(conData)        
    unpackedPortal=struct.unpack("ff",portalData)
    (portalX,portalY)=unpackedPortal
    feedChecksum(portalX,"f")
    feedChecksum(portalY,"f")
    print "portalX=%f portalY=%f"%unpackedPortal

    print ""

    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
    cameraData = f.read(40)
    cameraStuff = struct.unpack("10I",cameraData)
    for cs in cameraStuff:
        feedChecksum(cs,"I")
    print formatBinaryBuffer(cameraData)

    print ""

    #read tool flags
    if (features&FEATURE_FLAG_TOOLS)!=0:
        toolData = f.read(10)
        tools = struct.unpack("10B",toolData)
        toolStr = ""
        for tool in tools:
            feedChecksum(tool,"B")
            toolStr+="%02X "%(tool)
        print "tools=%s"%(toolStr)

    checkSumData = f.read(4)
    (checksum,)=struct.unpack("I",checkSumData)
    print "checksum = 0x%08X calculated = 0x%08X (0x%08X)"%(checksum,xorCheck,xor(checksum,xorCheck))
    print "offset = 0x%08X, remainder=%d"%(f.tell(),size-f.tell())
    assert(f.tell() == size)
    print ""
    print "---------------------------------------"
    print ""
    return (checksum,xorCheck,unknownBlock)

results = []
basedir = "c:\\Program Files\\Armadillo Run\\Levels\\"
#for file in os.listdir(basedir):
for file in files:
    (name,ext)=os.path.splitext(file)
    if ext==".lvl":
        (origname,ext) = os.path.splitext(name)
        if ext=="":
            res = parseFile(os.path.join(basedir,file))
            results.append((file,res))
for (filename,res) in results:
    (saved,calculated,unknown) = res
    print "filename %s 0x%08X 0x%08X (0x%08X) %s"%(filename,saved,calculated,xor(saved,calculated),unknown)