import os
import Image
import ImageDraw
import ImageColor
import ImageFont

import DilloStuff
reload(DilloStuff)

overSize = 4

offset = (512*overSize,512*overSize)
#offset = (512*overSize,1224*overSize)
scale = (50.0*overSize,-50.0*overSize)
pointSize = 4*overSize
anchorSize = 7*overSize

labelIndices = 1

dilloDir = r"C:\Program Files\Armadillo Run\Levels"
filename = "Inside_Out_BFC_ARForumContest_IV.TheBurden.lvl"



pointColours = [
    "Black",
    "Black",
    "Green"
]

linkColours =[
    "Tan",
    "Blue",
    "lightGrey",
    "DarkGrey",
    "Orange",
    "Black",
    "Red",
    ]

linkWeights =[
    5,
    5,
    5,
    5,
    5,
    7,
    10,
    ]

drawPasses = [
    [DilloStuff.LINKTYPE_RUBBER,DilloStuff.LINKTYPE_PLATE,DilloStuff.LINKTYPE_CLOTH,DilloStuff.LINKTYPE_ROCKET],
    [DilloStuff.LINKTYPE_BAR],
    [DilloStuff.LINKTYPE_ELASTIC,DilloStuff.LINKTYPE_ROPE],
]

f = ImageFont.truetype("ARIALBD.TTF",50)

def drawLevel(level,imageSize):
    (sizeX,sizeY)=imageSize
    im = Image.new("RGBA",(sizeX*overSize,sizeY*overSize),"White")
    draw = ImageDraw.Draw(im)

#    unKnownIndices = list(struct.unpack("%dI"%(level.unknownDataSize/4),level.unknownData))
#    print `unKnownIndices`

    for passTypes in drawPasses:
        for link in level.links:
            if link.type in passTypes:
                drawLink(draw,link)

    for point in level.points:
        drawPoint(draw,point)
        
    

    return im.resize(imageSize,Image.BILINEAR)

def transform(p):
    return(p[0]*scale[0]+offset[0],p[1]*scale[1]+offset[1])

def drawPoint(draw,point):
    global pointSize
    p = transform((point.x,point.y))
    if point.type == DilloStuff.POINT_TYPE_ANCHOR:
        box = (p[0]-anchorSize,p[1]-anchorSize,p[0]+anchorSize,p[1]+anchorSize)
        draw.ellipse(box, outline=pointColours[point.type],fill="Grey")
    box = (p[0]-pointSize,p[1]-pointSize,p[0]+pointSize,p[1]+pointSize)
    draw.ellipse(box, fill=pointColours[point.type])
    if labelIndices:
        text = "%d"%point.index
        size = draw.textsize(text,f)
        (tw,th) = size
        textPos = (p[0]-tw/2,p[1]-th/2)
        draw.text(textPos,text,fill="red",font=f)
    
def drawLink(draw,link):
    p1 = transform((link.fromPoint.x,link.fromPoint.y))
    p2 = transform((link.toPoint.x,link.toPoint.y))
#    print `link.type`
    colour = linkColours[link.type]
    fontColour = "green"
    
    draw.line(p1+p2,fill=colour,width=linkWeights[link.type]*overSize)
    if labelIndices:
        text = "%d"%link.index
        size = draw.textsize(text,f)
        (tw,th) = size
        textPos = ((p1[0]+p2[0])/2-tw/2,(p1[1]+p2[1])/2-th/2)
        draw.text(textPos,text,fill=fontColour,font=f)

level = DilloStuff.DilloLevel()
level.load(os.path.join(dilloDir,filename))
im = drawLevel(level,(1024,1024))
im.save(os.path.splitext(filename)[0]+".png")
